'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAutoBind = require('react-auto-bind');

var _reactAutoBind2 = _interopRequireDefault(_reactAutoBind);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LazyCard = function (_Component) {
  _inherits(LazyCard, _Component);

  function LazyCard(props, context) {
    _classCallCheck(this, LazyCard);

    var _this = _possibleConstructorReturn(this, (LazyCard.__proto__ || Object.getPrototypeOf(LazyCard)).call(this, props, context));

    _this.state = {
      image: props.lazyLoad ? props.defaultImage : props.defaultImage || props.image
    };

    (0, _reactAutoBind2.default)(_this);
    return _this;
  }

  _createClass(LazyCard, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.autoLoad) this.load();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
    }
  }, {
    key: 'load',
    value: function load() {
      var _this2 = this;

      var image = this.props.image;

      if (image && this.state.image !== image) {
        var img = new Image();
        img.src = image;
        img.onload = function () {
          _this2.setState({
            image: image
          });
        };
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          width = _props.width,
          image = _props.image,
          attributes = _props.attributes,
          children = _props.children,
          title = _props.title,
          className = _props.className;


      var style = {};

      if (width) style.width = width;
      if (this.state.image) style.backgroundImage = 'url(\'' + this.state.image + '\')';

      var mainClass = (0, _classnames2.default)('rs-img', className, {
        'rs-loaded': this.state.image === image
      });

      return _react2.default.createElement(
        'div',
        _extends({
          className: mainClass,
          style: style,
          title: title
        }, attributes),
        children
      );
    }
  }]);

  return LazyCard;
}(_react.Component);

exports.default = LazyCard;


LazyCard.propTypes = {
  className: _react.PropTypes.string,

  // additional attributes for the root node
  attributes: _react.PropTypes.object,

  // should the component automatically lazy Load
  autoLoad: _react.PropTypes.bool,

  // width of slide component
  width: _react.PropTypes.number,

  // url of the main image
  image: _react.PropTypes.string,

  // url of placeholder image
  defaultImage: _react.PropTypes.string,

  // title for the image
  // serves similar to alt attribute for image
  // only for the purpose of SEO
  title: _react.PropTypes.string,

  subTitle: _react.PropTypes.string,

  lazyLoad: _react.PropTypes.bool,

  data: _react.PropTypes.object,

  children: _react.PropTypes.oneOfType([_react.PropTypes.array, _react.PropTypes.object])
};

LazyCard.defaultProps = {
  title: '',
  attributes: {},
  autoLoad: false,
  lazyLoad: true,
  data: {}
};